Attribute VB_Name = "uniDll"
Option Explicit

'---------------------------------------------------------------------------------------
' Module    : uniDll
' Author    : mq
' Version   : 2007/Feb/5
' Copyright : deister electronic GmbH
'
' This file includes the declarations necessary to control the unikonDrv driver
' from a VB6 application.
'
' This file is provided "as is" with no expressed or implied warranty.
' The author accepts no liability for any damage/loss of business that
' this product may cause.
'
'---------------------------------------------------------------------------------------

'---------------------------------------------------------------------------------------
' Functions exported by unikonDrv.dll
'---------------------------------------------------------------------------------------

Declare Function uniDllVersion Lib "unikonDrv.dll" (ByVal lpDllVersion As String) As Long

Declare Function uniOpenComms Lib "unikonDrv.dll" (ByVal nPortNumber As Long) As Long

Declare Function uniCloseComms Lib "unikonDrv.dll" () As Long

Declare Function uniSetProtocol Lib "unikonDrv.dll" (ByVal nProtocol As Long) As Long

Declare Function uniSetCallBack Lib "unikonDrv.dll" (ByVal lpfnCallBack As Long) As Long

Declare Function uniCancel Lib "unikonDrv.dll" () As Long

Declare Function uniVersionCommand Lib "unikonDrv.dll" (ByVal lpReturnedString As String, ByVal nSize As Long) As Long

Declare Function uniResetAssignmentFlag Lib "unikonDrv.dll" () As Long

Declare Function uniUploadAdministrationData Lib "unikonDrv.dll" (ByVal lpFileName As String) As Long

Declare Function uniDownloadAdministrationData Lib "unikonDrv.dll" (ByVal lpFileName As String) As Long

Declare Function uniDownloadRaceData Lib "unikonDrv.dll" (ByVal lpFileName As String) As Long

Declare Function uniUploadLiberationPointSets Lib "unikonDrv.dll" (ByVal lpFileName As String) As Long

Declare Function uniInformationCommand Lib "unikonDrv.dll" (ByVal lpReturnedString As String, ByVal maxBytes As Long) As Long

Declare Function uniAutoDetectDevice Lib "unikonDrv.dll" (ByRef nPortNumber As Long) As Long

'---------------------------------------------------------------------------------------
' Return values / error codes
'---------------------------------------------------------------------------------------
Enum uniERRORCODES
  uni_OK = 0
  uni_ERROR = 1001
  uni_COMPORT_INVALID = 1002
  uni_COMPORT_OPEN_FAILED = 1003
  uni_COMPORT_TRANSMISSION_ERROR = 1004
  uni_PARAMETER_INVALID = 1005
  uni_COMPORT_NOTOPEN = 1006
  uni_COMPORT_TIMEOUT = 1007
  uni_COMPORT_EOT_RECEIVED = 1008
  uni_COMPORT_NAK_RECEIVED = 1009
  uni_BUSY = 1010
  uni_CANCELED = 1011
  uni_EXCEPTION = 1012
  uni_ERR_FILENOTFOUND = 1046
  uni_ERR_FILEOPEN = 1047
  uni_ERR_FILEREAD = 1048
  uni_ERR_FILEWRITE = 1049
  uni_ERR_FILEACCESS = 1050
  uni_ERR_WRONGDATA = 1051
End Enum

'---------------------------------------------------------------------------------------
' Status messages passed in the <statusInfo> variable to user callback function
'---------------------------------------------------------------------------------------
Enum uniSTATUSFLAGS
  SI_RECORD_UPLOADED = 1
  SI_RECORD_DOWNLOADED = 11
  SI_AUTODETECT_CHECK_PORT = 21
End Enum

'---------------------------------------------------------------------------------------
' Function : uniErrDescription
' Purpose   : get a textual description for a return value from Unikon Driver
' (This is optional! It is used in our little demo application)
'---------------------------------------------------------------------------------------

Public Function uniErrDescription(errNum As Long) As String
  Select Case errNum
  Case uni_OK:                          uniErrDescription = "uni_OK"
  Case uni_ERROR:                       uniErrDescription = "uni_ERROR"
  Case uni_COMPORT_INVALID:             uniErrDescription = "uni_COMPORT_INVALID"
  Case uni_COMPORT_OPEN_FAILED:         uniErrDescription = "uni_COMPORT_OPEN_FAILED"
  Case uni_COMPORT_TRANSMISSION_ERROR:  uniErrDescription = "uni_COMPORT_TRANSMISSION_ERROR"
  Case uni_PARAMETER_INVALID:           uniErrDescription = "uni_PARAMETER_INVALID"
  Case uni_COMPORT_NOTOPEN:             uniErrDescription = "uni_COMPORT_NOTOPEN"
  Case uni_COMPORT_TIMEOUT:             uniErrDescription = "uni_COMPORT_TIMEOUT"
  Case uni_COMPORT_EOT_RECEIVED:        uniErrDescription = "uni_COMPORT_EOT_RECEIVED"
  Case uni_COMPORT_NAK_RECEIVED:        uniErrDescription = "uni_COMPORT_NAK_RECEIVED"
  Case uni_BUSY:                        uniErrDescription = "uni_BUSY"
  Case uni_CANCELED:                    uniErrDescription = "uni_CANCELED"
  Case uni_EXCEPTION:                   uniErrDescription = "uni_EXCEPTION"
  Case uni_ERR_FILENOTFOUND:            uniErrDescription = "uni_ERR_FILENOTFOUND"
  Case uni_ERR_FILEOPEN:                uniErrDescription = "uni_ERR_FILEOPEN"
  Case uni_ERR_FILEOPEN:                uniErrDescription = "uni_ERR_FILEOPEN"
  Case uni_ERR_FILEREAD:                uniErrDescription = "uni_ERR_FILEREAD"
  Case uni_ERR_FILEWRITE:               uniErrDescription = "uni_ERR_FILEWRITE"
  Case uni_ERR_FILEACCESS:              uniErrDescription = "uni_ERR_FILEACCESS"
  Case uni_ERR_WRONGDATA:               uniErrDescription = "uni_ERR_WRONGDATA"
  Case Else:                            uniErrDescription = "unknown error"
  End Select
End Function

